c
c-----------------------------------------------------------------------
c
      real*8 function distance (xi, yi, zi, xj, yj, zj)
c
c.....distance - computes the distance between (xi,yi,zi) and
c     (xj,yj,zj) points:
c
      include           'implicit.inc'
      include           'molec.inc'
      real*8            xi, yi, zi, xj, yj, zj
c
      real*8            xx, yy, zz, d2
c
      xx = (xi - xj) * ared
      yy = (yi - yj) * bred
      zz = (zi - zj) * cred
      d2 = xx * xx + yy * yy + zz * zz + 2d0 *
     &     (xx * yy * cgamm + yy * zz * calph + zz * xx * cbeta)
      distance = sqrt(d2)
      return
      end
