c
c-----------------------------------------------------------------------
c
      real*8 function erfcc (x)
c
c.....erfcc - computes the complementary error function with an error
c             smaller than 1e-7.
c
      include           'implicit.inc'
      real*8            x, z, t
      real*8            one, two, half
      parameter         (one = 1d0,  two = 2d0,  half = 0.5d0)
c
      z = abs(x)
      t = one / (one + half * z)
      erfcc = t*exp(-z*z-1.26551223d0+t*(1.00002368d0+t*(.37409196d0+
     &    t*(.09678418d0+t*(-.18628806d0+t*(.27886807d0+
     &    t*(-1.13520398d0+
     &    t*(1.48851587d0+t*(-.82215223d0+t*.17087277d0)))))))))
      if (x.lt.0d0) erfcc = two - erfcc
      return
      end
