c
c-----------------------------------------------------------------------
c
      subroutine fclose (u)
c
c.....fclose - close and deallocate a file
c
      include           'strtools.inc'
      include           'error.inc'
      include           'iox.inc'
      integer           u
c
      integer           ios
c
      if (u.le.0 .or. u.gt.mopen) then
         call error ('fclose', 'illegal unit number', faterr)
      else
         if (access(u) .ne. ioread) then
            call fflush (u)
         endif
         close (unit=u, iostat=ios, err=10)
         call fdealloc (u)
      endif
      return
c
 10   call error ('fclose', 'error closing file', faterr)
      return
      end
