c
c-----------------------------------------------------------------------
c
      subroutine hashinit ()
c
c.....hashinit - initialize hashed table storage for variables and
c     keywords.
c
      include           'strtools.inc'
      include           'hash.inc'
      include           'tokens.inc'
c
      bpointer = 1
      nvars = 0
      do i = 1, mvars
         varpos(i) = 0
         nextvar(i) = 0
         varrvalue(i) = 0d0
         varivalue(i) = 0
      enddo
      do i = 1, mhsize
         htable(i) = 0
      enddo
      hsize = 251
c
c.....Install predefined constants:
c
      call hinstall ('PI'//null, acos(-1.0d0), 0, htconst)
      call hinstall ('E'//null, exp(1d0), 0, htconst)
c
c.....Install function names:
c
      call hinstall ('ABS'//null,    0d0, ft_abs,    htfunction)
      call hinstall ('SQRT'//null,   0d0, ft_sqrt,   htfunction)
      call hinstall ('LOG'//null,    0d0, ft_log,    htfunction)
      call hinstall ('LOG10'//null,  0d0, ft_log10,  htfunction)
      call hinstall ('SIN'//null,    0d0, ft_sin,    htfunction)
      call hinstall ('COS'//null,    0d0, ft_cos,    htfunction)
      call hinstall ('TAN'//null,    0d0, ft_tan,    htfunction)
      call hinstall ('ASIN'//null,   0d0, ft_asin,   htfunction)
      call hinstall ('ACOS'//null,   0d0, ft_acos,   htfunction)
      call hinstall ('ATAN'//null,   0d0, ft_atan,   htfunction)
      call hinstall ('EXP'//null,    0d0, ft_exp,    htfunction)
      call hinstall ('SINH'//null,   0d0, ft_sinh,   htfunction)
      call hinstall ('COSH'//null,   0d0, ft_cosh,   htfunction)
      call hinstall ('TANH'//null,   0d0, ft_tanh,   htfunction)
      call hinstall ('INT'//null,    0d0, ft_int,    htfunction)
      call hinstall ('FRAC'//null,   0d0, ft_frac,   htfunction)
      call hinstall ('FACT'//null,   0d0, ft_fact,   htfunction)
      call hinstall ('MOD'//null,    0d0, ft_mod,    htfunction)
      call hinstall ('ERF'//null,    0d0, ft_erf,    htfunction)
      call hinstall ('ERFC'//null,   0d0, ft_erfc,   htfunction)
      call hinstall ('ATAN2'//null,  0d0, ft_atan2,  htfunction)
      call hinstall ('IGAMMA'//null, 0d0, ft_igamma, htfunction)
      call hinstall ('SGN'//null,    0d0, ft_sgn,    htfunction)
      call hinstall ('MIN'//null,    0d0, ft_min,    htfunction)
      call hinstall ('MAX'//null,    0d0, ft_max,    htfunction)
      call hinstall ('IF'//null,     0d0, ft_if,     htfunction)
c
      end
