c
c-----------------------------------------------------------------------
c
      logical function fgetvarname (word, line, lp)
c
c.....fgetvarname - gets next variable name in line at lp. Returns
c     .true. if any is found, and .false. otherwise.
c
c     Avariable is defined as a letter followed of a sucession of
c     letters, digits or underscores:
c
c          VARIABLE :  [a..z | A..Z] {a..z | A..Z | 0..9 | _}
c
      include           'strtools.inc'
      character*(*)     word, line
      integer           lp
c
      integer           wp, i
      character*(1)     ch
      logical           isletter, isoksign
c
      isletter (ch) =  (ch.ge.'a' .and. ch.le.'z') .or.
     &                 (ch.ge.'A' .and. ch.le.'Z')
      isoksign (ch) =  (ch.ge.'a' .and. ch.le.'z') .or.
     &                 (ch.ge.'A' .and. ch.le.'Z') .or.
     &                 (ch.ge.'0' .and. ch.le.'9') .or.
     &                 (ch.eq.'_')
c
      do while (line(lp:lp) .eq. blank)
         lp = lp + 1
      enddo
      wp = 1
      if (isletter(line(lp:lp))) then
         word(wp:wp) = line(lp:lp)
         wp = wp + 1
         lp = lp + 1
         do while (isoksign(line(lp:lp)))
            word(wp:wp) = line(lp:lp)
            wp = wp + 1
            lp = lp + 1
         enddo
         word(wp:wp) = null
         do i = wp+1, len(word)
            word(i:i) = null
         enddo
         fgetvarname = .true.
      else
         word = null
         fgetvarname = .false.
      endif
      return
      end
