c
c-----------------------------------------------------------------------
c
      subroutine spawn (line)
c
c.....spawn - call the operating system to run the command contained in
c     'line' in a separate shell. This order is completely dependent on
c     the Operating System.
c
c     IMPORTANT NOTE: This routine may be a security concern, as
c     it tries to do whatever command appears in 'line'.
c
c     Implemented versions: unix, VMS.
c
      include           'implicit.inc'
      include           'strtools.inc'
c
      character*(*)     line
      integer           leng
c
*mdc*if unix linux g77
c
      call system (line(1:leng(line)))
c
*mdc*else if VMS
*      include           '($clidef)'
*      integer           status, lib$spawn, flags
*c
*      flags = CLI$M_NOKEYPAD
*      if (leng(line) .gt. 0) then
*         status = lib$spawn(line(1:leng(line)),,,flags)
*         if (status .ne. 0) call lib$signal(%val(status))
*      endif
*      return
*mdc*endif
      end
